#addprocs(2)
#@show nprocs()

using RoME
using Test
using TensorCast
import Manifolds
using Manifolds: ProductManifold, SpecialEuclidean, ProductRepr, SpecialOrthogonal, TranslationGroup, identity_element
using DistributedFactorGraphs
using Statistics


@error("must restore testG2oParser.jl")
@error("must restore testParametric.jl")
@error("add test for generateGraph_Beehive!, norm( simulated - default ) < tol")

testfiles = [  
  # known broken tests
  # "testParametric.jl"; # deferred
  # "testG2oParser.jl";  # deferred

  # dev test first, for faster issues.
  # ...

  # tests most likely to fail on numerics
  "testScalarFields.jl";
  "testPoint2Point2Init.jl";
  "threeDimLinearProductTest.jl";
  "testPose3Pose3NH.jl";
  
  # recent development work
  "testPartialPose3.jl";
  "testBearingRange2D.jl";
  "testBearing2D.jl";
  "testMultimodalRangeBearing.jl"; # restore after Bearing factors are fixed

  # regular tests expected to pass
  "testpackingconverters.jl";
  "testInflation380.jl";
  "testPoint2Point2.jl";
  "testParametricSimulated.jl";
  "testBasicPose2Conv.jl";
  "testGraphGenerators.jl";
  "testTreeInitCommonMsg_IIF913.jl";
  "testHexagonal2D_CliqByCliq.jl";      # special case debugging
  "testhigherdimroots.jl";
  "testDidsonFunctions.jl";
  "testBasicPose2Stationary.jl";
  "TestPoseAndPoint2Constraints.jl";
  "testPartialRangeCrossCorrelations.jl";
  "testDynPoint2D.jl";
  "testDeltaOdo.jl";
  "testFixedLagFG.jl";
  "testDynPose2D.jl";
  "testPartialPriorYawPose2.jl";
  "TestDefaultFGInitialization.jl";
  "testAccumulateFactors.jl";
  "testDeadReckoningTether.jl"; 
  "testFluxModelsPose2.jl";
  "testGenerateHelix.jl";

  # starts multiprocess.
  # don't move up, special factors defined in other test files are not added to multiprocess (Distributed.jl)
  "testBeehiveGrow.jl"; # also starts multiprocess
]


## Tests not ready yet
# "HexagonalLightGraphs.jl"
# "testCameraFunctions.jl"
# "testmultiplefeatures.jl"


for testf in testfiles
  println("[TEST] $testf =============================================================")
  include(testf)
  println("[SUCCESS] $testf")
  println()
  println()
  println()
end


#